| EM datagrams on *.kmall format Reg.no. 410224 rev D

- Main Page
- Related Pages
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Data Fields

Data Fields
EMdgmMRZ_pingInfo_def Struct Reference

#MRZ - ping info. Information on vessel/system level, i.e. information common to all beams in the current ping.
More...

`#include <EMdgmFormat.h>`

## Data Fields
uint16_t | numBytesInfoData
uint16_t | padding0
Ping info
float | pingRate_Hz
uint8_t | beamSpacing
uint8_t | depthMode
uint8_t | subDepthMode
uint8_t | distanceBtwSwath
uint8_t | detectionMode
uint8_t | pulseForm
uint16_t | padding1
float | frequencyMode_Hz
float | freqRangeLowLim_Hz
float | freqRangeHighLim_Hz
float | maxTotalTxPulseLength_sec
float | maxEffTxPulseLength_sec
float | maxEffTxBandWidth_Hz
float | absCoeff_dBPerkm
float | portSectorEdge_deg
float | starbSectorEdge_deg
float | portMeanCov_deg
float | starbMeanCov_deg
int16_t | portMeanCov_m
int16_t | starbMeanCov_m
uint8_t | modeAndStabilisation
uint8_t | runtimeFilter1
uint16_t | runtimeFilter2
uint32_t | pipeTrackingStatus
float | transmitArraySizeUsed_deg
float | receiveArraySizeUsed_deg
float | transmitPower_dB
uint16_t | SLrampUpTimeRemaining
uint16_t | padding2
float | yawAngle_deg
Info of tx sector data block, EMdgmMRZ_txSectorInfo
uint16_t | numTxSectors
uint16_t | numBytesPerTxSector
Info at time of midpoint of first tx pulse
float | headingVessel_deg
float | soundSpeedAtTxDepth_mPerSec
float | txTransducerDepth_m
float | z_waterLevelReRefPoint_m
float | x_kmallToall_m
float | y_kmallToall_m
uint8_t | latLongInfo
uint8_t | posSensorStatus
uint8_t | attitudeSensorStatus
uint8_t | padding3
double | latitude_deg
double | longitude_deg
float | ellipsoidHeightReRefPoint_m

## Detailed Description

#MRZ - ping info. Information on vessel/system level, i.e. information common to all beams in the current ping.

## Field Documentation

uint16_t numBytesInfoData

Number of bytes in current struct.

uint16_t padding0

Byte alignment.

float pingRate_Hz

Ping rate. Filtered/averaged.

uint8_t beamSpacing

0 = Eqidistance
1 = Equiangle
2 = High density

uint8_t depthMode

Depth mode. Describes setting of depth in K-Controller. Depth mode influences the PUs choice of pulse length and pulse type. If operator has manually chosen the depth mode to use, this is flagged by adding 100 to the mode index.
Table for EM2040 and EM712:

Number | Auto setting | Number | Manual setting
--- | --- | --- | ---
0 | Very shallow | 100 | Very shallow
1 | Shallow | 101 | Shallow
2 | Medium | 102 | Medium
3 | Deep | 103 | Deep
4 | Very deep | 104 | Very deep
5 | Extra deep | 105 | Extra deep

uint8_t subDepthMode

For advanced use when depth mode is set manually. 0 = Sub depth mode is not used (when depth mode is auto).

uint8_t distanceBtwSwath

Achieved distance between swaths, in percent relative to required swath distance.
0 = function is not used
100 = achieved swath distance equals required swath distance.

uint8_t detectionMode

Detection mode. Bottom detection algorithm used.
0 = normal
1 = waterway
2 = tracking
3 = minimum depth

uint8_t pulseForm

Pulse forms used for current swath.
0 = CW
1 = mix
2 = FM

uint16_t padding1

Ping rate. Filtered/averaged.

float frequencyMode_Hz

Ping frequency in hertz. E.g. for EM 2040: 200 000 Hz, 300 000 Hz or 400 000 Hz. If values is less than 100, it refers to a code defined in the table below.

Value | Frequency | Valid for EM model
--- | --- | ---
-1 | Not used | -
0 | 40 - 100 kHz | EM 710, EM 712
1 | 50 - 100 kHz | EM 710, EM 712
2 | 70 - 100 kHz | EM 710, EM 712
3 | 50 kHz | EM 710, EM 712
4 | 40 kHz | EM 710, EM 712
180 000 - 400 000 | 180 -400 kHz | EM 2040C (10 kHz steps)
200 000 | 200 kHz | EM 2040
300 000 | 300 kHz | EM 2040
400 000 | 400 kHz | EM 2040

float freqRangeLowLim_Hz

Lowest centre frequency of all sectors in this swath. Unit hertz. E.g. for EM 2040: 260 000 Hz.

float freqRangeHighLim_Hz

Highest centre frequency of all sectors in this swath. Unit hertz. E.g. for EM 2040: 320 000 Hz.

float maxTotalTxPulseLength_sec

Total signal length of the sector with longest tx pulse. Unit second.

float maxEffTxPulseLength_sec

Effective signal length (-3dB envelope) of the sector with longest effective tx pulse. Unit second.

float maxEffTxBandWidth_Hz

Effective bandwidth (-3dB envelope) of the sector with highest bandwidth.

float absCoeff_dBPerkm

Average absorption coefficient, in dB/km, for vertical beam at current depth. Not currently in use.

float portSectorEdge_deg

Port sector edge, used by beamformer, Coverage is refered to z of SCS.. Unit degree.

float starbSectorEdge_deg

Starboard sector edge, used by beamformer. Coverage is referred to z of SCS. Unit degree.

float portMeanCov_deg

Coverage achieved, corrected for raybending. Coverage is referred to z of SCS. Unit degree.

float starbMeanCov_deg

Coverage achieved, corrected for raybending. Coverage is referred to z of SCS. Unit degree.

int16_t portMeanCov_m

Coverage achieved, corrected for raybending. Coverage is referred to z of SCS. Unit meter.

int16_t starbMeanCov_m

Coverage achieved, corrected for raybending. Unit meter.

uint8_t modeAndStabilisation

Modes and stabilisation settings as chosen by operator. Each bit refers to one setting in K-Controller. Unless otherwise stated, default: 0 = off, 1 = on/auto.

Bit | Mode
--- | ---
1 | Pitch stabilisation
2 | Yaw stabilisation
3 | Sonar mode
4 | Angular coverage mode
5 | Sector mode
6 | Swath along position (0 = fixed, 1 = dynamic)
7-8 | Future use

uint8_t runtimeFilter1

Filter settings as chosen by operator. Refers to settings in runtime display of K-Controller. Each bit refers to one filter setting. 0 = off, 1 = on/auto.

Bit | Filter choice
--- | ---
1 | Slope filter
2 | Aeration filer
3 | Sector filter
4 | Interference filter
5 | Special amplitude detect
6-8 | Future use

uint16_t runtimeFilter2

Filter settings as chosen by operator. Refers to settings in runtime display of K-Controller. 4 bits used per filter.

Bit | Filter choice | Setting
--- | --- | ---
1-4 | Range gate size | 0 = small, 1 = normal, 2 = large
5-8 | Spike filter strength | 0 = off, 1= weak, 2 = medium, 3 = strong
9-12 | Penetration filter | 0 = off, 1 = weak, 2 = medium, 3 = strong
13-16 | Phase ramp | 0 = short, 1 = normal, 2 = long

uint32_t pipeTrackingStatus

Pipe tracking status. Describes how angle and range of top of pipe is determined.
0 = for future use
1 = PU uses guidance from SIS.

float transmitArraySizeUsed_deg

Transmit array size used. Direction along ship. Unit degree.

float receiveArraySizeUsed_deg

Receiver array size used. Direction across ship. Unit degree.

float transmitPower_dB

Operator selected tx power level re maximum. Unit dB. E.g. 0 dB, -10 dB, -20 dB.

uint16_t SLrampUpTimeRemaining

For marine mammal protection. The parameters describes time remaining until max source level (SL) is achieved. Unit %.

uint16_t padding2

Byte alignment.

float yawAngle_deg

Yaw correction angle applied. Unit degree.

uint16_t numTxSectors

Number of transmit sectors. Also called Ntx in documentation. Denotes how many times the struct EMdgmMRZ_txSectorInfo is repeated in the datagram.

uint16_t numBytesPerTxSector

Number of bytes in the struct EMdgmMRZ_txSectorInfo, containing tx sector specific information. The struct is repeated numTxSectors times.

float headingVessel_deg

Heading of vessel at time of midpoint of first tx pulse. From active heading sensor.

float soundSpeedAtTxDepth_mPerSec

At time of midpoint of first tx pulse. Value as used in depth calculations. Source of sound speed defined by user in K-Controller.

float txTransducerDepth_m

Tx transducer depth in meters below waterline, at time of midpoint of first tx pulse. For the tx array (head) used by this RX-fan. Use depth of TX1 to move depth point (XYZ) from water line to transducer (reference point of old datagram format).

float z_waterLevelReRefPoint_m

Distance between water line and vessel reference point in meters. At time of midpoint of first tx pulse. Measured in the surface coordinate system (SCS).See Coordinate systems 'Coordinate systems' for definition. Used this to move depth point (XYZ) from vessel reference point to waterline.

float x_kmallToall_m

Distance between *.all reference point and *.kmall reference point (vessel refernece point) in meters, in the surface coordinate system, at time of midpoint of first tx pulse. Used this to move depth point (XYZ) from vessel reference point to the horisontal location (X,Y) of the active position sensor's reference point (old datagram format).

float y_kmallToall_m

Distance between *.all reference point and *.kmall reference point (vessel refernece point) in meters, in the surface coordinate system, at time of midpoint of first tx pulse. Used this to move depth point (XYZ) from vessel reference point to the horisontal location (X,Y) of the active position sensor's reference point (old datagram format).

uint8_t latLongInfo

Method of position determination from position sensor data:
0 = last position received
1 = interpolated
2 = processed

uint8_t posSensorStatus

Status/quality for data from active position sensor. 0 = valid data, 1 = invalid data, 2 = reduced performance. To be specified in later release.

uint8_t attitudeSensorStatus

Status/quality for data from active attitude sensor. To be specified in later release.

uint8_t padding3

Padding for byte alignment.

double latitude_deg

Latitude (decimal degrees) of vessel reference point at time of midpoint of first tx pulse. Negative on southern hemisphere. Parameter is set to define UNAVAILABLE_LATITUDE if not available.

double longitude_deg

Longitude (decimal degrees) of vessel reference point at time of midpoint of first tx pulse. Negative on western hemisphere. Parameter is set to define UNAVAILABLE_LONGITUDE if not available.

float ellipsoidHeightReRefPoint_m

Height of vessel reference point above the ellipsoid, derived from active GGA sensor. ellipsoidHeightReRefPoint_m is GGA height corrected for motion and installation offsets of the position sensor.

The documentation for this struct was generated from the following file:

- EMdgmFormat.h